/*
 * MineFieldGUI.java
 *
 * Created on 19 novembre 2004, 23.45
 */

package sid.gui;


import javax.swing.*;
import java.awt.*;
/**
 *
 * @author  matteo
 */
public class MineFieldGUI extends javax.swing.JFrame {
    
    //interfaccia grafica padre
    private SimulationGUI parent;
    //panel su cui disegnare i componenti del campo minato
    JPanel glass;
    
    //gridLayout associato a questo pannello
    GridLayout gL;
    
    //numero di celle lungo x
    private int x;
    
    //numero di celle lungo y
    private int y;
    
    //matrice contenente i valori tramite i quali settare le icone sul panel
    //significato valori 
    //-1 = cella vuota
    //0 = disegna una mina
    //1 = agente che vede
    //2 =agente che smina
    //3 = green flag
    private int[][] mineFieldObject;
    
    
    /**
     *dimensioni del glassPanel
     */
     private Dimension glassDim;
    
    /** Creates new form MineFieldGUI
     *
     *@param x numero di caselle lungo x
     *@param y numero di caselle lungo y
     *
     */
    public MineFieldGUI(SimulationGUI parent,int x,int y) {
        initComponents();
        
        this.parent=parent;
        this.gL=new GridLayout(y,x);
       
        this.x=x;
        this.y=y;
        
        this.glass=(JPanel)this.getGlassPane();
        
        this.glassDim=new Dimension(705,705);
        
        this.glass.setSize(this.glassDim);
        this.glass.setLayout(this.gL);
        this.glass.setVisible(true);
        
        /*
        
        this.glass.setVisible(true);
        JLabel l=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\mine.gif"));
        l.setSize(46,46);
        JLabel l1=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\mine.gif"));
        l1.setSize(46,46);
        JLabel l2=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\mine.gif"));
        l2.setSize(46,46);
        JLabel l3=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\mine.gif"));
        l3.setSize(46,46);

        JLabel l4=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\mine.gif"));
        l4.setSize(46,46);
        
        JLabel l5=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\mine.gif"));
        l5.setSize(46,46);
        
        
        JLabel l6=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\mine.gif"));
        l5.setSize(46,46);
        
        JLabel l7=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\agentA.gif"));
        l5.setSize(46,46);
        
        JLabel l8=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\mine.gif"));
        l5.setSize(46,46);
        
        JLabel l9=new JLabel(new ImageIcon("G:\\lab\\classes\\images\\mine.gif"));
        l5.setSize(46,46);
        
        
        this.glass.add(l);
        this.glass.add(l1);
        this.glass.add(l2);
        this.glass.add(l3);
        this.glass.add(l4);
        this.glass.add(l5);
        this.glass.add(l6);
        this.glass.add(l7);
        this.glass.add(l8);
        this.glass.add(l9);
        /*this.glass.add(new JLabel(new ImageIcon("G:\\lab\\classes\\images\\guiIcon.gif")));
        this.glass.add(new JLabel(new ImageIcon("G:\\lab\\classes\\images\\guiIcon.gif")));
        this.glass.add(new JLabel(new ImageIcon("G:\\lab\\classes\\images\\guiIcon.gif")));
        this.glass.add(new JLabel(new ImageIcon("G:\\lab\\classes\\images\\guiIcon.gif")));
        this.glass.add(new JLabel(new ImageIcon("G:\\lab\\classes\\images\\guiIcon.gif")));
        this.glass.add(new JLabel(new ImageIcon("G:\\lab\\classes\\images\\guiIcon.gif")));
        */
        /*
        this.backGround=new JPanel();
        
        JLabel l=new JLabel();
        l.setSize(700,700);
        
        this.backGround.add(l);
        this.getContentPane().add(backGround);
        */
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();

        getContentPane().setLayout(null);

        setTitle("RunTimeSIM");
        setIconImage(new ImageIcon(SimulationGUI.userPath+"\\images\\guiIcon.gif").getImage());
        setUndecorated(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jLabel1.setIcon(new ImageIcon(SimulationGUI.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"mineField.gif"));
        getContentPane().add(jLabel1);
        jLabel1.setBounds(5, 5, 705, 705);

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new java.awt.Dimension(705, 705));
        setLocation((screenSize.width-705)/2,(screenSize.height-705)/2);
    }//GEN-END:initComponents
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     *carica/aggiorna il campo minato
     *@param matrix matrice degli oggetti da caricare sul panello del campo minato
     *@param init true se si tratta della prima inizializzazione del campo minato, false altrimenti
     *
     */
     public void paintMineField(int[][] matrix,boolean init){
         
         this.mineFieldObject=matrix;
         
         /*
          this.glass.removeAll();
         this.glass.repaint();
         */
         /*
         this.gL=new GridLayout(y,x);
         //rimuovo tutti gli elementi dal pannello
         this.glass.setLayout(this.gL);
         */
         
         
         //disegno gli oggetti sul pannello deputato allo scopo
         
         //scansiono le righe
         for(int i=0;i<this.y;i++){
             
             //scansione delle colonne
             for(int k=0;k<this.x;k++){
                 
                 //System.out.println("k: "+k+" i: "+i);
                 int element=this.mineFieldObject[i][k];
                 
                 /*
                 //rimuovo l'elemento solo se non si tratta della prima inizializzazione del campo minato
                 if(!init){
                     this.glass.removeAll();
                     this.glass.setLayout(this.gL);
                 }
                 */
                 switch(element){
                     
                     case 0:{
                         
                         JLabel l=new JLabel(new ImageIcon(SimulationGUI.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"mine.gif"));
                 
                         l.addMouseListener(new java.awt.event.MouseListener() {
                            public void mouseClicked(java.awt.event.MouseEvent evt) {
                                jLabelMineActionPerformed(evt);
                            }
                            
                            public void mousePressed(java.awt.event.MouseEvent evt){
                                jLabelMineActionPerformed(evt);
                            }
                            
                            public void mouseReleased(java.awt.event.MouseEvent evt){}
                            
                            public void mouseEntered(java.awt.event.MouseEvent evt){}
                            
                            public void mouseExited(java.awt.event.MouseEvent evt){}
                         });
                        
                         //l.setSize(800/sid.gui.SimulationGUI.X_DIMENSION,800/sid.gui.SimulationGUI.Y_DIMENSION);
                         //System.out.println("aggiunta mina");
                         this.glass.add(l);
                         break;
                     }
                     
                     case 1:{
                         JLabel l=new JLabel(new ImageIcon(SimulationGUI.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"agentA.gif"));
                         //l.setSize(46,46);
                         this.glass.add(l);
                         break;
                     }
                     
                     case 2:{
                         JLabel l=new JLabel(new ImageIcon(SimulationGUI.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"agentB.gif"));
                         //l.setSize(46,46);
                         this.glass.add(l);
                         break;
                     }
                     
                      case 3:{
                          
                         //System.out.println("bandiera verde");
                         JLabel l=new JLabel(new ImageIcon(SimulationGUI.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"greenFlag.gif"));
                         //l.setSize(46,46);
                         this.glass.add(l);
                         break;
                     }
                     
                     case 4:{
                          
                         
                         JLabel l=new JLabel(new ImageIcon(SimulationGUI.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"assignedMine.gif"));
                         //l.setSize(46,46);
                         
                         
                         
                         l.addMouseListener(new java.awt.event.MouseListener() {
                            public void mouseClicked(java.awt.event.MouseEvent evt) {
                                jLabelMineActionPerformed(evt);
                            }
                            
                            public void mousePressed(java.awt.event.MouseEvent evt){
                                jLabelMineActionPerformed(evt);
                            }
                            
                            public void mouseReleased(java.awt.event.MouseEvent evt){}
                            
                            public void mouseEntered(java.awt.event.MouseEvent evt){}
                            
                            public void mouseExited(java.awt.event.MouseEvent evt){}
                         });
                         
                         this.glass.add(l);
                         break;
                     }
                     
                     case 5:{
                          
                         //discovered mine
                         JLabel l=new JLabel(new ImageIcon(SimulationGUI.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"discoveredMine.gif"));
                         //l.setSize(46,46);
                         
                         l.addMouseListener(new java.awt.event.MouseListener() {
                            public void mouseClicked(java.awt.event.MouseEvent evt) {
                                jLabelMineActionPerformed(evt);
                            }
                            
                            public void mousePressed(java.awt.event.MouseEvent evt){
                                jLabelMineActionPerformed(evt);
                            }
                            
                            public void mouseReleased(java.awt.event.MouseEvent evt){}
                            
                            public void mouseEntered(java.awt.event.MouseEvent evt){}
                            
                            public void mouseExited(java.awt.event.MouseEvent evt){}
                         });
                         
                         this.glass.add(l);
                         break;
                     }
                     
                     case 6:{
                          
                         
                         JLabel l=new JLabel(new ImageIcon(SimulationGUI.userPath+sid.gui.SimulationGUI.fileSeparator+"images"+sid.gui.SimulationGUI.fileSeparator+"unminedMine.gif"));
                         //l.setSize(46,46);
                         this.glass.add(l);
                         break;
                     }
                     
                     default: {
                         
                         //JLabel l=new JLabel(new ImageIcon("G:\\lab\\classes\\images"+sid.gui.SimulationGUI.fileSeparator+"greenFlag.gif"));
                        JLabel l=new JLabel(""/*new ImageIcon(SimulationGUI.userPath+"\\images\\empty.gif")*/);
                        // l.setSize(800/sid.gui.SimulationGUI.X_DIMENSION,800/sid.gui.SimulationGUI.Y_DIMENSION);
                         this.glass.add(l);
                         break;
                         
                     }
                     
                     
                 }//switch
                 
             }
         }
         
         //this.glass.repaint();
         this.repaint();
         
     }//paintMineField
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new MineFieldGUI(null,0,0).show();
    }
    
    /**
     *utilizzato per rispondere ad eventi di pressione del mouse
     *su aree della mappa rappresentanti mine: rimuove la mina "cliccata" sia dall'interfaccia grafica
     *che dal tc mineField
     *@param evt l'evento che ha provocato l'esecuzione di questo metodo
     */
     private void jLabelMineActionPerformed(java.awt.event.MouseEvent evt){
        
         //label che  stata cliccata
         JLabel clicked=(JLabel)evt.getSource();
         
         
         
        //coordinate relative alla pressione sullo schermo del cursore del mouse
        Point l=clicked.getLocation();
        int actualX=(int)l.getX()+1;
        int actualY=(int)l.getY()+1;
        
        //System.out.println("coord x: "+actualX+" coordy. "+actualY);
        
        //recupero la coordinata x e quella y relativa alla mina da rimuovere
        int xTotSize=(int)this.glassDim.getWidth();
        int yTotSize=(int)this.glassDim.getHeight();
        
        int xCellSize=xTotSize/this.x;
        int yCellSize=yTotSize/this.y;
        
        //recupero la coordinata x della casella con la mina da rimuovere
        int xIndex=0; //coordinata x della mina da rimuovere
        int currentXSize=xCellSize;

        while(currentXSize<actualX){
            
            currentXSize+=xCellSize;
            xIndex++;
            
        }//while
        
        //recupero la coordinata y della casella con la mina da rimuovere
        int yIndex=0; //coordinata y della mina da rimuovere
        int currentYSize=yCellSize;

        while(currentYSize<actualY){
            
            currentYSize+=yCellSize;
            yIndex++;
            
        }//while
        
        
        System.out.println("x: "+xIndex+" y. "+yIndex);
        
        //cancellazione della tupla corrispondente
        boolean deleteTupleResult=this.parent.getSimulation().removeMine(xIndex,yIndex);
        
        //rimuovo l'icona dall'interfaccia grafica soltanto se  stata eliminata anche la tupla corrispondente
        if(deleteTupleResult){
            this.glass.remove(clicked);
            this.glass.repaint();
        }
        
        
     }//end-gestoreEvento
     
     /**
      *utilizzato dal parent di questa finesta per chiuderla nel caso in cui
      *si siano verificati errori a run-time su una simulazione in esecuzione
      */
     public void close(){
         this.dispose();
     }//close
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    // End of variables declaration//GEN-END:variables
    
}
